/********************************************************************************************************************
-          HD744780
-       :  ASCII ->    Epson,  "Russian" 
-    
********************************************************************************************************************/
#include	"pic.h"
// PORTB (lcd)
#define rs  1
#define rw  2
#define en  3

#define bitset(var,bitno) ((var) |= 1 << (bitno)) 
#define bitclr(var,bitno) ((var) &= ~(1 << (bitno)))

 //-------------------------------
void delay(int);	//
void  interrupt tc_ovf(void);	//     
void wr_command_lcd(unsigned char);//   lcd
void wr_data_lcd(unsigned char);//    lcdzzz
//----------- --------
unsigned char lcd @ 0x06; // PORTB
const unsigned char rusTable[64]= { //    Epson,  "Russian" 
0x41, 0xA0, 0x42, 0xA1, 0xE0, 0x45, 0xA3, 0xA4, 0xA5, 0xA6, 0x4B, 0xA7, 0x4D, 0x48, 0x4F, 0xA8, 
0x50, 0x43, 0x54, 0xA9, 0xAA, 0x58, 0xE1, 0xAB, 0xAC, 0xE2, 0xAD, 0xAE, 0xAD, 0xAF, 0xB0, 0xB1, 
0x61, 0xB2, 0xB3, 0xB4, 0xE3, 0x65, 0xB6, 0xB7, 0xB8, 0xB9, 0xBA, 0xBB, 0xBC, 0xBD, 0x6F, 0xBE, 
0x70, 0x63, 0xBF, 0x79, 0xE4, 0x78, 0xE5, 0xC0, 0xC1, 0xE6, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7};

const unsigned char Message[16]= {", World"};
const unsigned char RunString[111]= 
{"             HD744780 - . Testing *,.!? Bye-bye,  amigo            "};
const unsigned char lineSize=111;
main() 
		{
		unsigned char i,currentPOS, lcdCod;
		TRISB=0x00;	
		di();


//--------- lcd-----------
	lcd=0;
	delay(1300);
	lcd=0x30;
	bitset (lcd, en); bitclr (lcd, en);// _/\_
	delay(7);	
	bitset (lcd, en); bitclr (lcd, en);// _/\_
	delay(230);
	wr_command_lcd(0x20);
	wr_command_lcd(0x28);	
	wr_command_lcd(0x0C);
	wr_command_lcd(0x06);
	wr_command_lcd(0x01);
	delay(230);
//----------  --------
wr_command_lcd(0x80);
	for	(i=0;i<16;i++) { 
						if (i==8) wr_command_lcd(0xC0); //   
		lcdCod= Message[i];		//  ,   ASCII 
		if (lcdCod > 0x7F) lcdCod=rusTable[Message[i]-0xC0]; //   ,       rusTable
		wr_data_lcd(lcdCod);	}	


delay(56000);
delay(56000);

	while(1) {

for (currentPOS=0; currentPOS<lineSize-16;currentPOS++) {
//----------  --------
	wr_command_lcd(0x80);
	for	(i=currentPOS;i<currentPOS+16;i++) {
						if (i==currentPOS+8) wr_command_lcd(0xC0); //   				
		lcdCod= RunString[i];
		if (lcdCod > 0x7F) lcdCod=rusTable[RunString[i]-0xC0];
		wr_data_lcd(lcdCod); }

	delay(24000);	
	}


	}

	}
//=====      =======
void  interrupt tc_ovf(void) {
	unsigned char  A;
	unsigned char BCD;
	di();
	TMR0=0x65;
	T0IF=0;
	ei();
	}

//============--  T=19us+k*13us __ k=(T-19us)/13us --==========
void delay(kmax) 
	{	unsigned int ki;
	for (ki=0; ki<kmax; ki++);//""    
					}		  //


//=============     lcd  =======
void wr_command_lcd(unsigned char cmd_lcd) {
	bitclr (lcd,rs); bitclr (lcd,rw);
	lcd=cmd_lcd & 0xF0;
	bitset (lcd, en); bitclr (lcd, en);// _/\_
	lcd=(cmd_lcd<<4) & 0xF0;
	bitset (lcd, en); bitclr (lcd, en);// _/\_
	delay(230);
	}
// =============     lcd =======
void wr_data_lcd(unsigned char dat_lcd) {
	bitset (lcd,rs); bitclr (lcd,rw);
	lcd=(dat_lcd & 0xF0) | 0x02;
	bitset (lcd, en); bitclr (lcd, en);// _/\_
	lcd=((dat_lcd<<4) & 0xF0) | 0x02;
	bitset (lcd, en); bitclr (lcd, en);// _/\_	
	delay(230);
	bitclr (lcd,rs);
}
